diff --git a/game/client/src/main/java/net/minecraft/client/render/Lighting.java b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
index 206bd726c..71754b6de 100644
--- a/game/client/src/main/java/net/minecraft/client/render/Lighting.java
+++ b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
@@ -1,33 +1,28 @@
 package net.minecraft.client.render;
 
-import static org.lwjgl.opengl.GL11.*;
-
-import java.nio.FloatBuffer;
-
-import net.minecraft.client.GLAllocation;
+import net.minecraft.client.render.renderer.GLRenderer;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Math;
 import org.joml.Vector3f;
+import org.joml.Vector4f;
 
-public class Lighting {
-    private static final @NotNull FloatBuffer buffer = GLAllocation.createDirectFloatBuffer(16);
-    private static final @NotNull Vector3f vec = new Vector3f();
-
-    public Lighting() {
+public final class Lighting {
+    private Lighting() {
     }
 
     public static void disable() {
-        glDisable(GL_LIGHTING);
-        glDisable(GL_LIGHT0);
-        glDisable(GL_LIGHT1);
-        glDisable(GL_COLOR_MATERIAL);
+        GLRenderer.globalSetLightEnabled(false);
+        GLRenderer.globalGetLight0().enabled = false;
+        GLRenderer.globalGetLight1().enabled = false;
+//        glDisable(GL_COLOR_MATERIAL);
     }
 
     public static void enableInventoryLight() {
-        glPushMatrix();
-        glRotatef(-30.0f, 0.0F, 1.0F, 0.0F);
-        glRotatef(155.0f, 1.0F, 0.0F, 0.0F);
         enableLight(0.4f, 0.5f);
-        glPopMatrix();
+        GLRenderer.globalGetNormalTransformMatrix()
+            .rotateY(Math.toRadians(-30.0f))
+            .rotateX(Math.toRadians(155.0f))
+            .invert();
     }
 
     public static void enableLight() {
@@ -35,37 +30,55 @@ public class Lighting {
     }
 
     public static void enableLight(float ambientBrightness, float lightBrightness) {
-        glEnable(GL_LIGHTING);
-        glEnable(GL_LIGHT0);
-        glEnable(GL_LIGHT1);
-        glEnable(GL_COLOR_MATERIAL);
-        glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
-
-        vec.set(0.2f, 1.0f, -0.7f).normalize();
-        glLightfv(GL_LIGHT0, GL_POSITION, getBuffer(vec.x, vec.y, vec.z, 0.0f));
-        glLightfv(GL_LIGHT0, GL_DIFFUSE, getBuffer(lightBrightness, lightBrightness, lightBrightness, 1.0F));
-        glLightfv(GL_LIGHT0, GL_AMBIENT, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
-        glLightfv(GL_LIGHT0, GL_SPECULAR, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
+        GLRenderer.globalGetNormalTransformMatrix().identity();
+        GLRenderer.globalSetLightEnabled(true);
+        GLRenderer.globalGetLight0().enabled = true;
+        GLRenderer.globalGetLight1().enabled = true;
+//        glEnable(GL_COLOR_MATERIAL);
+//        glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
 
-        vec.set(-0.2f, 1.0f, 0.7f).normalize();
-        glLightfv(GL_LIGHT1, GL_POSITION, getBuffer(vec.x, vec.y, vec.z, 0.0f));
-        glLightfv(GL_LIGHT1, GL_DIFFUSE, getBuffer(lightBrightness, lightBrightness, lightBrightness, 1.0F));
-        glLightfv(GL_LIGHT1, GL_AMBIENT, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
-        glLightfv(GL_LIGHT1, GL_SPECULAR, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
+        GLRenderer.globalGetLight0().position.set(0.2f, 1.0f, -0.7f).normalize();
+        GLRenderer.globalGetLight0().diffuse.set(lightBrightness, lightBrightness, lightBrightness, 1f);
+        GLRenderer.globalGetLight0().ambient.set(0, 0, 0, 1f);
+        GLRenderer.globalGetLight0().specular.set(0, 0, 0, 1f);
 
-        glShadeModel(GL_FLAT);
-        glLightModelfv(GL_LIGHT_MODEL_AMBIENT, getBuffer(ambientBrightness, ambientBrightness, ambientBrightness, 1.0F));
+        GLRenderer.globalGetLight1().position.set(-0.2f, 1f, 0.7f).normalize();
+        GLRenderer.globalGetLight1().diffuse.set(lightBrightness, lightBrightness, lightBrightness, 1f);
+        GLRenderer.globalGetLight1().ambient.set(0, 0, 0, 1f);
+        GLRenderer.globalGetLight1().specular.set(0, 0, 0, 1f);
+//
+//        glShadeModel(GL_FLAT);
+        GLRenderer.globalGetLightModelAmbient().set(ambientBrightness, ambientBrightness, ambientBrightness, 1.0F);
     }
 
-    private static @NotNull FloatBuffer getBuffer(double d1, double d2, double d3, double d4) {
-        return getBuffer((float) d1, (float) d2, (float) d3, (float) d4);
-    }
+    public static class LightSource {
+        public boolean enabled = false;
+        public final @NotNull Vector4f ambient = new Vector4f(0, 0, 0, 1);
+        public final @NotNull Vector4f diffuse = new Vector4f(0, 0, 0, 1);
+        public final @NotNull Vector4f specular = new Vector4f(0, 0, 0, 1);
+        public final @NotNull Vector4f position = new Vector4f(0, 0, 1, 0);
+        public final @NotNull Vector3f spotDirection = new Vector3f(0, 0, -1);
+        public float spotExponent = 0; // [0, 128]
+        public float spotCutoff = 180; // [0, 90] U [180]
+        public float constantAttenuation = 1f;
+        public float linearAttenuation = 0f;
+        public float quadraticAttenuation = 0f;
 
-    private static @NotNull FloatBuffer getBuffer(float f1, float f2, float f3, float f4) {
-        buffer.clear();
-        buffer.put(f1).put(f2).put(f3).put(f4);
-        buffer.flip();
-        return buffer;
-    }
+        public LightSource() {
+            reset();
+        }
 
+        public void reset() {
+            this.ambient.set(0, 0, 0, 1);
+            this.diffuse.set(0, 0, 0, 1);
+            this.specular.set(0, 0, 0, 1);
+            this.position.set(0, 0, 1, 0);
+            this.spotDirection.set(0, 0, -1);
+            this.spotExponent = 0;
+            this.spotCutoff = 180;
+            this.constantAttenuation = 1f;
+            this.linearAttenuation = 0f;
+            this.quadraticAttenuation = 0f;
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
index 13ec0ce71..acfee9305 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
@@ -29,6 +29,7 @@ final public class LightingCache {
 
     private Block<?> block;
     private WorldSource access;
+    private final @NotNull TilePos queryPos = new TilePos();
 
     @Deprecated
     public void setupCache(@NotNull Block<?> block, @NotNull WorldSource source, int x, int y, int z) {
@@ -50,29 +51,23 @@ final public class LightingCache {
         final int blockId = this.access.getBlockId(tilePos);
         final Block<?> block = Blocks.getBlock(blockId);
 
-        if (LightmapHelper.isLightmapEnabled() || this.mc.fullbright) {
-            if (this.block.emission >= 15) {
-                return 1.0f;
-            }
-            if (!this.mc.isAmbientOcclusionEnabled()) {
-                return 1.0f;
-            }
-            if (block == null) {
-                return 1.0f;
-            }
-            return 1.0f - block.getAmbientOcclusionStrength(this.access, tilePos);
+        if (this.block.emission >= 15) {
+            return 1.0f;
         }
-        final int emission = Blocks.lightEmission[blockId];
-        final float brightness = this.access.getBrightness(tilePos, emission);
-
-        return Math.min(brightness, (this.mc.isAmbientOcclusionEnabled() && block != null) ? (1 - block.getAmbientOcclusionStrength(this.access, tilePos)) : 1);
+        if (!this.mc.isAmbientOcclusionEnabled()) {
+            return 1.0f;
+        }
+        if (block == null) {
+            return 1.0f;
+        }
+        return 1.0f - block.getAmbientOcclusionStrength(this.access, tilePos);
     }
 
     public float getBrightness(int relX, int relY, int relZ) {
         int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
 
         if (!this.brightnessCached[index]) {
-            this.brightnessValue[index] = calcBrightness(this.offset.add(relX, relY, relZ, new TilePos()));
+            this.brightnessValue[index] = calcBrightness(this.offset.add(relX, relY, relZ, this.queryPos));
             this.brightnessCached[index] = true;
         }
 
@@ -82,7 +77,7 @@ final public class LightingCache {
     public boolean getOpacity(int relX, int relY, int relZ) {
         int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
         if (!this.opacityCached[index]) {
-            this.opacityValue[index] = Blocks.solid[this.access.getBlockId(this.offset.add(relX, relY, relZ, new TilePos()))];
+            this.opacityValue[index] = Blocks.solid[this.access.getBlockId(this.offset.add(relX, relY, relZ, this.queryPos))];
             this.opacityCached[index] = true;
         }
         return this.opacityValue[index];
@@ -92,7 +87,7 @@ final public class LightingCache {
         int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
         if (!this.lightmapCoordCached[index]) {
             int lightEmission = this.block.emission;
-            this.lightmapCoordValue[index] = this.access.getLightmapCoord(this.offset.add(relX, relY, relZ, new TilePos()), lightEmission);
+            this.lightmapCoordValue[index] = this.access.getLightmapCoord(this.offset.add(relX, relY, relZ, this.queryPos), lightEmission);
             this.lightmapCoordCached[index] = true;
         }
         return this.lightmapCoordValue[index];
diff --git a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
index b8f4c115d..a7cf0ac3b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightmapHelper.java
@@ -1,7 +1,5 @@
 package net.minecraft.client.render;
 
-import static org.lwjgl.opengl.GL13.*;
-
 import java.awt.image.BufferedImage;
 import java.nio.ByteBuffer;
 import java.util.Arrays;
@@ -13,21 +11,15 @@ import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.util.helper.Buffer;
+import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
 public class LightmapHelper {
 	private static final Logger LOGGER = LogUtils.getLogger();
 	public static LightmapHelper instance = null;
-	private static int currentSkyCoord = 0;
-	private static int currentBlockCoord = 0;
-	private static int lastSkyCoord = 0;
-	private static int lastBlockCoord = 0;
-
-	public static boolean isLightmapEnabled() {
-		return instance != null && instance.isEnabled();
-	}
 
 	public final Minecraft mc;
 	public final WorldRenderer worldRenderer;
@@ -40,70 +32,69 @@ public class LightmapHelper {
 	public float skyDarkenSmooth;
 
 	public LightmapHelper(Minecraft mc, WorldRenderer worldRenderer) {
+		instance = this;
 		this.mc = mc;
 		this.worldRenderer = worldRenderer;
-		instance = this;
+		Arrays.fill(this.lightmapData, 0xFFFFFFFF);
+		setLightmapTextureData(this.lightmapData);
+		enableLightmapRendering();
 	}
 	
 	public void setup() {
-		World world = mc.currentWorld;
-		if(mc.gameSettings.customLightmap.value && world != null) {
+		World world = this.mc.currentWorld;
+		if(this.mc.gameSettings.customLightmap.value && world != null) {
 			int dimension = world.dimension.id;
 			
 			String path = "/assets/minecraft/textures/environment/lightmap" + dimension + ".png";
 
             LOGGER.info("Attempting to load custom lightmap '{}'", path);
-			customLightmap = mc.textureManager.getImage(path);
+            this.customLightmap = this.mc.textureManager.getImage(path);
 			
-			if(customLightmap == Textures.missingTexture) {
-				customLightmap = null;
+			if(this.customLightmap == Textures.missingTexture) {
+                this.customLightmap = null;
 			}
 			
-			if(customLightmap != null) {
+			if(this.customLightmap != null) {
 				LOGGER.info("Loaded custom lightmap!");
 			}else {
-				LOGGER.warn("No custom lightmap found.");
+				LOGGER.info("No custom lightmap found.");
 			}
 		}else {
-			customLightmap = null;
+            this.customLightmap = null;
 		}
 	}
 
-	public boolean isEnabled() {
-		return mc.gameSettings.lightmapStyle.value != LightmapStyle.DISABLED;
-	}
-	
 	public void tick() {
-		World world = mc.currentWorld;
+		World world = this.mc.currentWorld;
 		if(world == null) {
 			return;
 		}
-		
-		prevSkyDarken = skyDarkenSmooth;
+
+        this.prevSkyDarken = this.skyDarkenSmooth;
 		
 		float skyDarken = world.skyDarken;
 		
 		if(Math.abs(this.skyDarkenSmooth - skyDarken) > 1.5f) {
 			this.skyDarkenSmooth = this.prevSkyDarken = skyDarken;
 		}else {
-			skyDarkenSmooth = MathHelper.lerp(skyDarken, skyDarkenSmooth, 0.99f);
+            this.skyDarkenSmooth = MathHelper.lerp(skyDarken, this.skyDarkenSmooth, 0.99f);
 		}
 	}
 
 	public void update(float partialTicks) {
-		World world = mc.currentWorld;
+		World world = this.mc.currentWorld;
 
-		if(!isEnabled() || world == null) {
+		if(world == null) {
 			return;
 		}
 
-		if(mc.fullbright) {
-            Arrays.fill(lightmapData, 0xFFFFFFFF);
+		if(this.mc.fullbright) {
+            Arrays.fill(this.lightmapData, 0xFFFFFFFF);
 		} else {
-			if(mc.gameSettings.customLightmap.value && customLightmap != null) {
+			if(this.mc.gameSettings.customLightmap.value && this.customLightmap != null) {
 				generateCustomLightmap(world);
 			}else {
-				LightmapStyle lightmapStyle = mc.gameSettings.lightmapStyle.value;
+				LightmapStyle lightmapStyle = this.mc.gameSettings.lightmapStyle.value;
 				
 				if(lightmapStyle == LightmapStyle.COLORIZED) {
 					generateColorizedLightmap(world, partialTicks);
@@ -114,55 +105,28 @@ public class LightmapHelper {
 		}
 
 		OpenGLHelper.checkError("pre generate lightmap");
-		setLightmapTextureData(lightmapData);
+		setLightmapTextureData(this.lightmapData);
 		OpenGLHelper.checkError("generate lightmap");
 	}
 
 	public void disableLightmapRendering() {
-		glClientActiveTexture(GL_TEXTURE1);
-		glActiveTexture(GL_TEXTURE1);
-
-		glDisable(GL_TEXTURE_2D);
-
-		glClientActiveTexture(GL_TEXTURE0);
-		glActiveTexture(GL_TEXTURE0);
+//		glClientActiveTexture(GL_TEXTURE1);
+//		glActiveTexture(GL_TEXTURE1);
+//
+//		glDisable(GL_TEXTURE_2D);
+//
+//		glClientActiveTexture(GL_TEXTURE0);
+//		glActiveTexture(GL_TEXTURE0);
 	}
 
 	public void enableLightmapRendering() {
-		if(!isEnabled()) {
-			return;
-		}
-
-		OpenGLHelper.checkError("pre enable lightmap");
-
-		// Switch active texture
-		glClientActiveTexture(GL_TEXTURE1);
-		glActiveTexture(GL_TEXTURE1);
-
-		// Setup texture matrix
-		glMatrixMode(GL_TEXTURE);
-		glLoadIdentity();
-
-		float scale = 1.0f / 256.0f;
-		glScalef(scale, scale, scale);
-		glTranslatef(8.0f, 8.0f, 8.0f);
-
-		glMatrixMode(GL_MODELVIEW);
-
-		// Bind texture
-		glBindTexture(GL_TEXTURE_2D, lightmapTexture);
-
-		// Back to default texture
-		glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
-		glEnable(GL_TEXTURE_2D);
-		glClientActiveTexture(GL_TEXTURE0);
-		glActiveTexture(GL_TEXTURE0);
-
-		OpenGLHelper.checkError("enable lightmap");
+		GL41.glActiveTexture(GL41.GL_TEXTURE1);
+		GL41.glBindTexture(GL41.GL_TEXTURE_2D, LightmapHelper.instance.lightmapTexture);
+		GL41.glActiveTexture(GL41.GL_TEXTURE0);
 	}
 
 	public void generateGrayLightmap(World world, float partialTicks) {
-		boolean smooth = mc.gameSettings.ambientOcclusion.value;
+		boolean smooth = this.mc.gameSettings.ambientOcclusion.value;
 		
 		for(int i = 0; i < 256; i++) {
 			final int skyLightLevel = i / 16;
@@ -170,9 +134,9 @@ public class LightmapHelper {
 
 			float brightness;
 			
-			if(smooth) {
-				float skyDarken = prevSkyDarken + (skyDarkenSmooth - prevSkyDarken) * partialTicks;
-				if(mc.currentScreen instanceof ScreenPhotoMode) {
+			if(smooth ) {
+				float skyDarken = this.prevSkyDarken + (this.skyDarkenSmooth - this.prevSkyDarken) * partialTicks;
+				if(this.mc.currentScreen instanceof ScreenPhotoMode) {
 					skyDarken = world.skyDarken;
 				}
 				float modifiedSkylight = Math.max(0, skyLightLevel - skyDarken);
@@ -184,20 +148,20 @@ public class LightmapHelper {
 				brightness = world.worldType.getBrightnessRamp()[light];
 			}
 			
-			brightness = applyGamma(brightness, mc.gameSettings.brightness.value - 0.5f);
+			brightness = applyGamma(brightness, this.mc.gameSettings.brightness.value - 0.5f);
 			brightness = MathHelper.clamp(brightness, 0.0f, 1.0f);
 
 			int brightnessI = (int) (brightness * 255);
 
 			int color = 0xFF000000 | brightnessI << 16 | brightnessI << 8 | brightnessI;
 
-			lightmapData[i] = color;
+            this.lightmapData[i] = color;
 		}
 	}
 	
 	public void generateColorizedLightmap(World world, float partialTicks) {
 		float ambientBrightness = world.getAmbientBrightness(partialTicks);
-		float brightness = mc.gameSettings.brightness.value - 0.5f;
+		float brightness = this.mc.gameSettings.brightness.value - 0.5f;
 
 		for(int i = 0; i < 256; i++) {
 			float skyLight = getBrightnessRemoveMinLight(world, i / 16) * (ambientBrightness * 0.95f + 0.05f);
@@ -235,22 +199,22 @@ public class LightmapHelper {
 			green = MathHelper.clamp(green, 0.0f, 1.0f);
 			blue = MathHelper.clamp(blue, 0.0f, 1.0f);
 
-			lightmapData[i] = toIntARGB(red, green, blue);
+            this.lightmapData[i] = Color.floatToIntARGB(1, red, green, blue);
 		}
 	}
 	
 	public void generateCustomLightmap(World world) {
 		float ambientBrightness = (world.getAmbientBrightness(1.0f) - 0.2f) / 0.8f;
-		float brightness = mc.gameSettings.brightness.value;
+		float brightness = this.mc.gameSettings.brightness.value;
 		
-		int skylightX = MathHelper.floor_float(ambientBrightness * (customLightmap.getWidth() - 2));
+		int skylightX = MathHelper.floor_float(ambientBrightness * (this.customLightmap.getWidth() - 2));
 		
 		for(int i=0; i < 256; i++) {
 			int blockLightIndex = i % 16;
 			int skyLightIndex = i / 16;
 			
-			int torchColor = customLightmap.getRGB(0, 16 + blockLightIndex);
-			int skyColor = customLightmap.getRGB(skylightX, skyLightIndex);
+			int torchColor = this.customLightmap.getRGB(0, 16 + blockLightIndex);
+			int skyColor = this.customLightmap.getRGB(skylightX, skyLightIndex);
 			
 			float torchRed   = ((torchColor >> 16) & 0xFF) / 255.0f;
 			float torchGreen = ((torchColor >>  8) & 0xFF) / 255.0f;
@@ -275,8 +239,8 @@ public class LightmapHelper {
 			red = MathHelper.clamp(red, 0.0f, 1.0f);
 			green = MathHelper.clamp(green, 0.0f, 1.0f);
 			blue = MathHelper.clamp(blue, 0.0f, 1.0f);
-			
-			lightmapData[i] = toIntARGB(red, green, blue);
+
+            this.lightmapData[i] = Color.floatToIntARGB(1f, red, green, blue);
 		}
 //		for(int i=0; i < 256; i++) {
 //			lightmapData[i] = 0xFFFF0000;
@@ -293,7 +257,7 @@ public class LightmapHelper {
 		for(int i = 0; i < data.length; i++) {
 			int color = data[i];
 
-			int a = color >> 24;
+			int a = (color >> 24) & 0xFF;
 			int r = (color >> 16) & 0xFF;
 			int g = (color >> 8) & 0xFF;
 			int b = color & 0xFF;
@@ -307,32 +271,24 @@ public class LightmapHelper {
 		buffer.position(0);
 		buffer.limit(16 * 16 * 4);
 
-		if(lightmapTexture == 0) {
-			lightmapTexture = GLAllocation.generateTexture();
-			glBindTexture(GL_TEXTURE_2D, lightmapTexture);
-			glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 16, 16, 0, GL_RGBA, GL_UNSIGNED_BYTE, (ByteBuffer) null);
+		if(this.lightmapTexture == 0) {
+            this.lightmapTexture = GLAllocation.generateTexture();
+			GL41.glBindTexture(GL41.GL_TEXTURE_2D, this.lightmapTexture);
+			GL41.glTexImage2D(GL41.GL_TEXTURE_2D, 0, GL41.GL_RGBA, 16, 16, 0, GL41.GL_RGBA, GL41.GL_UNSIGNED_BYTE, 0);
 		}
 
-		glBindTexture(GL_TEXTURE_2D, lightmapTexture);
-		glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 16, 16, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
+		GL41.glBindTexture(GL41.GL_TEXTURE_2D, this.lightmapTexture);
+		GL41.glTexSubImage2D(GL41.GL_TEXTURE_2D, 0, 0, 0, 16, 16, GL41.GL_RGBA, GL41.GL_UNSIGNED_BYTE, buffer);
 
-		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
-		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
+		GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MIN_FILTER, GL41.GL_LINEAR);
+		GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MAG_FILTER, GL41.GL_LINEAR);
 
-		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
-		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
+		GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_S, GL41.GL_CLAMP_TO_EDGE);
+		GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_WRAP_T, GL41.GL_CLAMP_TO_EDGE);
 
 		OpenGLHelper.checkError("set lightmap data");
 	}
 
-	public int toIntARGB(float red, float green, float blue) {
-		int a = 255;
-		int r = (int) (red * 255);
-		int g = (int) (green * 255);
-		int b = (int) (blue * 255);
-		return (a << 24) | (r << 16) | (g << 8) | b;
-	}
-
 	public float applyGamma(float color, float gamma) {
 		float color2 = 1.0f - color;
 		color2 = 1.0f - color2 * color2 * color2 * color2;
@@ -388,39 +344,6 @@ public class LightmapHelper {
 		return avg(avg(lmc0, lmc1), avg(lmc2, lmc3));
 	}
 	
-	public static void setLightmapCoord(int skylight, int blocklight) {
-		glMultiTexCoord2f(GL_TEXTURE1, blocklight * 16.0f, skylight * 16.0f);
-
-		lastBlockCoord = currentBlockCoord;
-		lastSkyCoord = currentSkyCoord;
-		currentBlockCoord = blocklight * 16;
-		currentSkyCoord = skylight * 16;
-	}
-	
-	public static void setLightmapCoord(int lightmapCoord) {
-		int sky = lightmapCoord >> 16;
-		int block = lightmapCoord & 0xFFFF;
-		
-		glMultiTexCoord2f(GL_TEXTURE1, block, sky);
-
-		lastBlockCoord = currentBlockCoord;
-		lastSkyCoord = currentSkyCoord;
-		currentBlockCoord = block;
-		currentSkyCoord = sky;
-	}
-
-	public static void setLastLightmapCoord() {
-		int sky = lastSkyCoord;
-		int block = lastBlockCoord;
-
-		glMultiTexCoord2f(GL_TEXTURE1, block, sky);
-
-		lastBlockCoord = currentBlockCoord;
-		lastSkyCoord = currentSkyCoord;
-		currentBlockCoord = block;
-		currentSkyCoord = sky;
-	}
-	
 	public static int setBlocklightValue(int lightmapCoord, int blocklight) {
 		return lightmapCoord & 0xFFFF0000 | blocklight << 4;
 	}
